import { Address } from "..";
import { createTestClient } from "../tests/createTestClient";
import { toNano } from "../utils/convert";
import { awaitBalance } from "./awaitBalance";
import { openTestTreasure } from "./openTestTreasure";

describe('openTestTreasure', () => {
    it('should transfer funds from test treasure', async () => {
        const client = createTestClient();
        const wallet = await openTestTreasure(client);
        const seqno = await wallet.wallet.getSeqNo();
        const dest = Address.parseFriendly('EQClZ-KEDodcnyoyPX7c0qBBQ9QePzzquVwKuaqHk7F01825').address;
        let balance = await client.getBalance(dest);
        await wallet.wallet.transfer({
            to: dest,
            value: toNano(0.001),
            seqno,
            secretKey: wallet.secretKey,
            bounce: false
        });
        await awaitBalance(client, dest, balance);
    }, 60000);
});