import { mnemonicToWalletKey } from "ton-crypto";
import { TonClient } from "..";

// If tests are failing, please full this wallet with more coins:
// EQDR4neQzqkfEz0oR3hXBcJph64d5NddP8H8wfN0thQIAqDH
const testWalletMnemonics = [
    'circle', 'task', 'moral',
    'disagree', 'echo', 'kingdom',
    'agent', 'kite', 'love',
    'indoor', 'manage', 'orphan',
    'royal', 'business', 'whisper',
    'saddle', 'sun', 'dog',
    'street', 'cart', 'flash',
    'cheese', 'swift', 'turkey'
];

export async function openTestTreasure(client: TonClient) {
    const key = await mnemonicToWalletKey(testWalletMnemonics);
    return {
        secretKey: key.secretKey,
        publicKey: key.publicKey,
        wallet: await client.findWalletFromSecretKey({ workchain: 0, secretKey: key.secretKey })
    };
}